VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   2475
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   3585
   LinkTopic       =   "Form1"
   ScaleHeight     =   2475
   ScaleWidth      =   3585
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox Err 
      Height          =   285
      Left            =   240
      TabIndex        =   8
      Text            =   "0"
      Top             =   1440
      Width           =   1215
   End
   Begin VB.TextBox SP 
      Height          =   285
      Left            =   240
      TabIndex        =   6
      Text            =   "0"
      Top             =   1080
      Width           =   1215
   End
   Begin VB.TextBox ADC2 
      Height          =   285
      Left            =   240
      TabIndex        =   4
      Text            =   "0"
      Top             =   720
      Width           =   1215
   End
   Begin VB.TextBox Lamp 
      Height          =   285
      Left            =   240
      TabIndex        =   2
      Text            =   "Text1"
      Top             =   1920
      Width           =   1215
   End
   Begin VB.TextBox ADC1 
      Height          =   285
      Left            =   240
      TabIndex        =   0
      Text            =   "0"
      Top             =   360
      Width           =   1215
   End
   Begin VB.Timer Timer1 
      Interval        =   100
      Left            =   2400
      Top             =   1200
   End
   Begin VB.Label Label5 
      Caption         =   "Error"
      Height          =   255
      Left            =   1560
      TabIndex        =   9
      Top             =   1440
      Width           =   1695
   End
   Begin VB.Label Setpoint 
      Caption         =   "Setpoint"
      Height          =   255
      Left            =   1560
      TabIndex        =   7
      Top             =   1080
      Width           =   1695
   End
   Begin VB.Label Label3 
      Caption         =   "LDR Reading"
      Height          =   255
      Left            =   1560
      TabIndex        =   5
      Top             =   720
      Width           =   1695
   End
   Begin VB.Label Label2 
      Caption         =   "Lamp Brightness"
      Height          =   255
      Left            =   1560
      TabIndex        =   3
      Top             =   1920
      Width           =   1695
   End
   Begin VB.Label Label1 
      Caption         =   "Pot Reading"
      Height          =   255
      Left            =   1560
      TabIndex        =   1
      Top             =   360
      Width           =   1695
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Set this to "1" if making an exe or "0" if debugging
'(so that the full paths are included in the declare statements)
#Const EXE_BUILD = 1

#If EXE_BUILD Then
    Private Declare Function ECIO_GetDLLVersion Lib "ECIO_api.dll" () As Long
    Private Declare Function ECIO_Open Lib "ECIO_api.dll" (ByVal index As Long, ByRef pVID_PID As Any) As Long
    Private Declare Function ECIO_Close Lib "ECIO_api.dll" () As Long
    Private Declare Function ECIO_Transmit Lib "ECIO_api.dll" (ByRef pDataOut As Any, ByVal dwLenOut As Long, ByRef pActualLenOut As Long, ByRef pDataIn As Any, ByVal dwExpectedLenIn As Long, ByRef pActualLenIn As Long, ByVal dwTimeout As Long) As Long
    Private Declare Function ECIO_GetDeviceCount Lib "ECIO_api.dll" (ByRef pVID_PID As Any) As Long
#Else
    Private Declare Function ECIO_GetDLLVersion Lib "C:\DEV\Flowcode V3\Components\USB Pack\Current\DLL Interface\V4\VB_App\ECIO_api.dll" () As Long
    Private Declare Function ECIO_Open Lib "C:\DEV\Flowcode V3\Components\USB Pack\Current\DLL Interface\V4\VB_App\ECIO_api.dll" (ByVal index As Long, ByRef pVID_PID As Any) As Long
    Private Declare Function ECIO_Close Lib "C:\DEV\Flowcode V3\Components\USB Pack\Current\DLL Interface\V4\VB_App\ECIO_api.dll" () As Long
    Private Declare Function ECIO_Transmit Lib "C:\DEV\Flowcode V3\Components\USB Pack\Current\DLL Interface\V4\VB_App\ECIO_api.dll" (ByRef pDataOut As Any, ByVal dwLenOut As Long, ByRef pActualLenOut As Long, ByRef pDataIn As Any, ByVal dwExpectedLenIn As Long, ByRef pActualLenIn As Long, ByVal dwTimeout As Long) As Long
    Private Declare Function ECIO_GetDeviceCount Lib "C:\DEV\Flowcode V3\Components\USB Pack\Current\DLL Interface\V4\VB_App\ECIO_api.dll" (ByRef pVID_PID As Any) As Long
#End If

Private sID(0 To 20) As Byte

Private Sub Form_Load()
    'Set the identifier
    sID(0) = Asc("v")
    sID(1) = Asc("i")
    sID(2) = Asc("d")
    sID(3) = Asc("_")
    sID(4) = Asc("1")
    sID(5) = Asc("2")
    sID(6) = Asc("b")
    sID(7) = Asc("f")
    sID(8) = Asc("&")
    sID(9) = Asc("p")
    sID(10) = Asc("i")
    sID(11) = Asc("d")
    sID(12) = Asc("_")
    sID(13) = Asc("0")
    sID(14) = Asc("2")
    sID(15) = Asc("1")
    sID(16) = Asc("0")
    sID(17) = 0

    Dim lRetVal As Long
    lRetVal = ECIO_Open(0, sID(0))
    
    Dim bDataOut(0 To 2) As Byte
    Dim bDataIn(0 To 2) As Byte
    Dim nTxDataCnt As Long
    Dim nRxDataCnt As Long
    
    'Enable PWM Output Channel 1
    bDataOut(0) = 13            'PWM Control Command
    bDataOut(1) = 1             'Output To channel A (PWM 1)
    bDataOut(2) = 1             'Enable Channel
    lRetVal = ECIO_Transmit(bDataOut(0), 3, nTxDataCnt, bDataIn(0), 3, nRxDataCnt, 500)

End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
    
    Dim lRetVal As Long
    Dim bDataOut(0 To 2) As Byte
    Dim bDataIn(0 To 2) As Byte
    Dim nTxDataCnt As Long
    Dim nRxDataCnt As Long
    
    'Change PWM Duty to 0
    bDataOut(0) = 14              'PWM Duty Control Command
    bDataOut(1) = 1             'Output To channel A (PWM 1)
    bDataOut(2) = 0             'Duty cycle off
    lRetVal = ECIO_Transmit(bDataOut(0), 3, nTxDataCnt, bDataIn(0), 3, nRxDataCnt, 500)
      
    'Disable PWM Outputs
    bDataOut(0) = 13            'PWM Control Command
    bDataOut(1) = 1             'Output To channel A (PWM 1)
    bDataOut(2) = 0             'Disable Channel
    lRetVal = ECIO_Transmit(bDataOut(0), 3, nTxDataCnt, bDataIn(0), 3, nRxDataCnt, 500)

    'Make sure the connection is closed
    ECIO_Close
End Sub


Private Sub Timer1_Timer()

    Dim lRetVal As Long
    Dim bDataOut(0 To 2) As Byte
    Dim bDataIn(0 To 2) As Byte
    Dim nTxDataCnt As Long
    Dim nRxDataCnt As Long

    Dim Pot As Byte
    Dim LDR As Byte
    Dim Setpoint As Byte
    Dim Error As Byte
    Dim Out As Byte
    
    'Read Analogue Sensor Channel
    bDataOut(0) = 3             'Analogue Input Command
    bDataOut(1) = 1             'Input Channel I1
    lRetVal = ECIO_Transmit(bDataOut(0), 3, nTxDataCnt, bDataIn(0), 3, nRxDataCnt, 500)
    
    Pot = bDataIn(0)
    ADC1.Text = Pot
    
    Setpoint = Pot / 5
    Setpoint = Setpoint + 150
    SP.Text = Setpoint
    
    'Read Analogue Sensor Channel
    bDataOut(0) = 3             'Analogue Input Command
    bDataOut(1) = 2             'Input Channel I2
    lRetVal = ECIO_Transmit(bDataOut(0), 3, nTxDataCnt, bDataIn(0), 3, nRxDataCnt, 500)
    
    LDR = bDataIn(0)
    ADC2.Text = LDR
    
    Error = Setpoint - LDR
    Error = Error / 10
    
    Err.Text = Error
    
    Out = Setpoint + Error
    Lamp.Text = Out
       
    'Update PWM Duty
    bDataOut(0) = 14            'PWM Duty Control Command
    bDataOut(1) = 1             'Output To channel A (PWM 1)
    bDataOut(2) = Out           'Duty cycle off
    lRetVal = ECIO_Transmit(bDataOut(0), 3, nTxDataCnt, bDataIn(0), 3, nRxDataCnt, 500)

End Sub
