Option Strict Off
Option Explicit On
Friend Class Form1
	Inherits System.Windows.Forms.Form
	'Set this to "1" if making an exe or "0" if debugging
	'(so that the full paths are included in the declare statements)
#Const EXE_BUILD = 1
	
#If EXE_BUILD Then
	Private Declare Function ECIO_GetDLLVersion Lib "ECIO_api.dll" () As Integer
    Private Declare Function ECIO_Open Lib "ECIO_api.dll" (ByVal index As Integer, ByRef pVID_PID As Byte) As Integer
	Private Declare Function ECIO_Close Lib "ECIO_api.dll" () As Integer
    Private Declare Function ECIO_Transmit Lib "ECIO_api.dll" (ByRef pDataOut As Byte, ByVal dwLenOut As Integer, ByRef pActualLenOut As Integer, ByRef pDataIn As Byte, ByVal dwExpectedLenIn As Integer, ByRef pActualLenIn As Integer, ByVal dwTimeout As Integer) As Integer
    Private Declare Function ECIO_GetDeviceCount Lib "ECIO_api.dll" (ByRef pVID_PID As Byte) As Integer
#Else
	Private Declare Function ECIO_GetDLLVersion Lib "C:\DEV\Flowcode V3\Components\USB Pack\Current\DLL Interface\V4\VB_App\ECIO_api.dll" () As Long
	Private Declare Function ECIO_Open Lib "C:\DEV\Flowcode V3\Components\USB Pack\Current\DLL Interface\V4\VB_App\ECIO_api.dll" (ByVal index As Long, ByRef pVID_PID As Any) As Long
	Private Declare Function ECIO_Close Lib "C:\DEV\Flowcode V3\Components\USB Pack\Current\DLL Interface\V4\VB_App\ECIO_api.dll" () As Long
	Private Declare Function ECIO_Transmit Lib "C:\DEV\Flowcode V3\Components\USB Pack\Current\DLL Interface\V4\VB_App\ECIO_api.dll" (ByRef pDataOut As Any, ByVal dwLenOut As Long, ByRef pActualLenOut As Long, ByRef pDataIn As Any, ByVal dwExpectedLenIn As Long, ByRef pActualLenIn As Long, ByVal dwTimeout As Long) As Long
	Private Declare Function ECIO_GetDeviceCount Lib "C:\DEV\Flowcode V3\Components\USB Pack\Current\DLL Interface\V4\VB_App\ECIO_api.dll" (ByRef pVID_PID As Any) As Long
#End If
	
	
	Private sID(20) As Byte
	
	Private Sub Form1_Load(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Load
		'Set the identifier
		sID(0) = Asc("v")
		sID(1) = Asc("i")
		sID(2) = Asc("d")
		sID(3) = Asc("_")
		sID(4) = Asc("1")
		sID(5) = Asc("2")
		sID(6) = Asc("b")
		sID(7) = Asc("f")
		sID(8) = Asc("&")
		sID(9) = Asc("p")
		sID(10) = Asc("i")
		sID(11) = Asc("d")
		sID(12) = Asc("_")
		sID(13) = Asc("0")
		sID(14) = Asc("2")
		sID(15) = Asc("1")
		sID(16) = Asc("0")
		sID(17) = 0
		
	End Sub
	
	Private Sub btnGetCount_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles btnGetCount.Click
		Dim lCnt As Integer
		
		lCnt = ECIO_GetDeviceCount(sID(0))
		Text1.Text = Text1.Text & "Count = " & lCnt & vbCrLf
	End Sub
	
	Private Sub btnOpen_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles btnOpen.Click
		Dim lRetVal As Integer
		
		lRetVal = ECIO_Open(0, sID(0))
		Text1.Text = Text1.Text & "Open = " & lRetVal & vbCrLf
		
	End Sub
	
	Private Sub btnTransmit_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles btnTransmit.Click
		Dim lRetVal As Integer
		Dim bDataOut(9) As Byte
		Dim bDataIn(8) As Byte

		bDataOut(0) = CByte(Byte0.Text)
		bDataOut(1) = CByte(Byte1.Text)
		bDataOut(2) = CByte(Byte2.Text)
		
		Dim nTxDataCnt As Integer
		Dim nRxDataCnt As Integer
		
		lRetVal = ECIO_Transmit(bDataOut(0), 9, nTxDataCnt, bDataIn(0), 32, nRxDataCnt, 800)
		
		Text1.Text = "Transmit txDataCnt = " & nTxDataCnt & vbCrLf
		Text1.Text = Text1.Text & "Transmit bDataOut(0) = " & bDataOut(0) & vbCrLf
		Text1.Text = Text1.Text & "Transmit bDataOut(1) = " & bDataOut(1) & vbCrLf
		Text1.Text = Text1.Text & "Transmit bDataOut(2) = " & bDataOut(2) & vbCrLf
		Text1.Text = Text1.Text & "Transmit bDataOut(3) = " & bDataOut(3) & vbCrLf
		Text1.Text = Text1.Text & "Transmit bDataOut(4) = " & bDataOut(4) & vbCrLf
		
		Text1.Text = Text1.Text & "Transmit return = " & lRetVal & vbCrLf
		Text1.Text = Text1.Text & "Transmit rxDataCnt = " & nRxDataCnt & vbCrLf
		Text1.Text = Text1.Text & "Transmit bDataIn(0) = " & bDataIn(0) & vbCrLf
		Text1.Text = Text1.Text & "Transmit bDataIn(1) = " & bDataIn(1) & vbCrLf
		Text1.Text = Text1.Text & "Transmit bDataIn(2) = " & bDataIn(2) & vbCrLf
		Text1.Text = Text1.Text & "Transmit bDataIn(3) = " & bDataIn(3) & vbCrLf
		Text1.Text = Text1.Text & "Transmit bDataIn(4) = " & bDataIn(4) & vbCrLf
	End Sub
	
	Private Sub btnClose_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles btnClose.Click
		Dim lRetVal As Integer
		lRetVal = ECIO_Close
		Text1.Text = Text1.Text & "Close = " & lRetVal & vbCrLf
	End Sub
	
	
	Private Sub Form1_FormClosing(ByVal eventSender As System.Object, ByVal eventArgs As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
		Dim Cancel As Boolean = eventArgs.Cancel
		Dim UnloadMode As System.Windows.Forms.CloseReason = eventArgs.CloseReason
		'Make sure the connection is closed
		ECIO_Close()
		eventArgs.Cancel = Cancel
	End Sub
End Class