Option Strict Off
Option Explicit On
Friend Class Form1
	Inherits System.Windows.Forms.Form
	'Set this to "1" if making an exe or "0" if debugging
	'(so that the full paths are included in the declare statements)
#Const EXE_BUILD = 1
	
#If EXE_BUILD Then
	Private Declare Function ECIO_GetDLLVersion Lib "ECIO_api.dll" () As Integer
    Private Declare Function ECIO_Open Lib "ECIO_api.dll" (ByVal index As Integer, ByRef pVID_PID As Byte) As Integer
	Private Declare Function ECIO_Close Lib "ECIO_api.dll" () As Integer
    Private Declare Function ECIO_Transmit Lib "ECIO_api.dll" (ByRef pDataOut As Byte, ByVal dwLenOut As Integer, ByRef pActualLenOut As Integer, ByRef pDataIn As Byte, ByVal dwExpectedLenIn As Integer, ByRef pActualLenIn As Integer, ByVal dwTimeout As Integer) As Integer
    Private Declare Function ECIO_GetDeviceCount Lib "ECIO_api.dll" (ByRef pVID_PID As Byte) As Integer
#Else
	Private Declare Function ECIO_GetDLLVersion Lib "C:\DEV\Flowcode V3\Components\USB Pack\Current\DLL Interface\V4\VB_App\ECIO_api.dll" () As Long
	Private Declare Function ECIO_Open Lib "C:\DEV\Flowcode V3\Components\USB Pack\Current\DLL Interface\V4\VB_App\ECIO_api.dll" (ByVal index As Long, ByRef pVID_PID As Any) As Long
	Private Declare Function ECIO_Close Lib "C:\DEV\Flowcode V3\Components\USB Pack\Current\DLL Interface\V4\VB_App\ECIO_api.dll" () As Long
	Private Declare Function ECIO_Transmit Lib "C:\DEV\Flowcode V3\Components\USB Pack\Current\DLL Interface\V4\VB_App\ECIO_api.dll" (ByRef pDataOut As Any, ByVal dwLenOut As Long, ByRef pActualLenOut As Long, ByRef pDataIn As Any, ByVal dwExpectedLenIn As Long, ByRef pActualLenIn As Long, ByVal dwTimeout As Long) As Long
	Private Declare Function ECIO_GetDeviceCount Lib "C:\DEV\Flowcode V3\Components\USB Pack\Current\DLL Interface\V4\VB_App\ECIO_api.dll" (ByRef pVID_PID As Any) As Long
#End If
	
	
	Private sID(20) As Byte
	Private state As Byte
	
	
	Private Sub Form1_Load(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Load
		'Set the identifier
		sID(0) = Asc("v")
		sID(1) = Asc("i")
		sID(2) = Asc("d")
		sID(3) = Asc("_")
		sID(4) = Asc("1")
		sID(5) = Asc("2")
		sID(6) = Asc("b")
		sID(7) = Asc("f")
		sID(8) = Asc("&")
		sID(9) = Asc("p")
		sID(10) = Asc("i")
		sID(11) = Asc("d")
		sID(12) = Asc("_")
		sID(13) = Asc("0")
		sID(14) = Asc("2")
		sID(15) = Asc("1")
		sID(16) = Asc("0")
		sID(17) = 0
		
		state = 0
		
		Dim lRetVal As Integer
		lRetVal = ECIO_Open(0, sID(0))
		
	End Sub
	
	Private Sub Form1_FormClosing(ByVal eventSender As System.Object, ByVal eventArgs As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
		Dim Cancel As Boolean = eventArgs.Cancel
		Dim UnloadMode As System.Windows.Forms.CloseReason = eventArgs.CloseReason
		'Make sure the connection is closed
		ECIO_Close()
		eventArgs.Cancel = Cancel
	End Sub
	
	Private Sub Timer1_Tick(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Timer1.Tick
		
		Dim rstate As Byte
		Dim astate As Byte
		Dim gstate As Byte
		
		Dim lRetVal As Integer
		Dim bDataOut(2) As Byte
		Dim bDataIn(2) As Byte
		Dim nTxDataCnt As Integer
		Dim nRxDataCnt As Integer
		
		If (state = 0) Then
			rstate = 1
			astate = 0
			gstate = 0
		End If
		
		If (state = 1) Then
			rstate = 1
			astate = 1
			gstate = 0
		End If
		
		If (state = 2) Then
			rstate = 0
			astate = 0
			gstate = 1
		End If
		
		If (state = 3) Then
			rstate = 0
			astate = 1
			gstate = 0
		End If
		
		state = state + 1
		
		If (state = 4) Then state = 0
		
		red.CheckState = rstate
		amber.CheckState = astate
		green.CheckState = gstate
		
		bDataOut(0) = 7 'Digital Output Transistor Command
		bDataOut(1) = 1 'Output To channel A (RED)
		bDataOut(2) = rstate 'Value of button
		lRetVal = ECIO_Transmit(bDataOut(0), 3, nTxDataCnt, bDataIn(0), 3, nRxDataCnt, 500)
		
		bDataOut(0) = 7 'Digital Output Transistor Command
		bDataOut(1) = 2 'Output To channel B (AMBER)
		bDataOut(2) = astate 'Value of button
		lRetVal = ECIO_Transmit(bDataOut(0), 3, nTxDataCnt, bDataIn(0), 3, nRxDataCnt, 500)
		
		bDataOut(0) = 7 'Digital Output Transistor Command
		bDataOut(1) = 3 'Output To channel C (GREEN)
		bDataOut(2) = gstate 'Value of button
		lRetVal = ECIO_Transmit(bDataOut(0), 3, nTxDataCnt, bDataIn(0), 3, nRxDataCnt, 500)
		
	End Sub
End Class