VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   2565
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   5400
   LinkTopic       =   "Form1"
   ScaleHeight     =   2565
   ScaleWidth      =   5400
   StartUpPosition =   3  'Windows Default
   Begin VB.Timer Timer2 
      Interval        =   100
      Left            =   2280
      Top             =   1080
   End
   Begin VB.CommandButton Press 
      Caption         =   "Press to walk"
      Height          =   375
      Left            =   3120
      TabIndex        =   4
      Top             =   1200
      Width           =   1335
   End
   Begin VB.CheckBox Walk 
      Caption         =   "Walk"
      Height          =   255
      Left            =   3480
      TabIndex        =   3
      Top             =   720
      Width           =   735
   End
   Begin VB.Timer Timer1 
      Interval        =   2000
      Left            =   2280
      Top             =   360
   End
   Begin VB.CheckBox Green 
      Caption         =   "GREEN"
      Height          =   495
      Left            =   840
      TabIndex        =   2
      Top             =   1680
      Width           =   1095
   End
   Begin VB.CheckBox Amber 
      Caption         =   "AMBER"
      Height          =   495
      Left            =   840
      TabIndex        =   1
      Top             =   960
      Width           =   1095
   End
   Begin VB.CheckBox Red 
      Caption         =   "RED"
      Height          =   495
      Left            =   840
      TabIndex        =   0
      Top             =   240
      Width           =   1095
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Set this to "1" if making an exe or "0" if debugging
'(so that the full paths are included in the declare statements)
#Const EXE_BUILD = 1

#If EXE_BUILD Then
    Private Declare Function ECIO_GetDLLVersion Lib "ECIO_api.dll" () As Long
    Private Declare Function ECIO_Open Lib "ECIO_api.dll" (ByVal index As Long, ByRef pVID_PID As Any) As Long
    Private Declare Function ECIO_Close Lib "ECIO_api.dll" () As Long
    Private Declare Function ECIO_Transmit Lib "ECIO_api.dll" (ByRef pDataOut As Any, ByVal dwLenOut As Long, ByRef pActualLenOut As Long, ByRef pDataIn As Any, ByVal dwExpectedLenIn As Long, ByRef pActualLenIn As Long, ByVal dwTimeout As Long) As Long
    Private Declare Function ECIO_GetDeviceCount Lib "ECIO_api.dll" (ByRef pVID_PID As Any) As Long
#Else
    Private Declare Function ECIO_GetDLLVersion Lib "C:\DEV\Flowcode V3\Components\USB Pack\Current\DLL Interface\V4\VB_App\ECIO_api.dll" () As Long
    Private Declare Function ECIO_Open Lib "C:\DEV\Flowcode V3\Components\USB Pack\Current\DLL Interface\V4\VB_App\ECIO_api.dll" (ByVal index As Long, ByRef pVID_PID As Any) As Long
    Private Declare Function ECIO_Close Lib "C:\DEV\Flowcode V3\Components\USB Pack\Current\DLL Interface\V4\VB_App\ECIO_api.dll" () As Long
    Private Declare Function ECIO_Transmit Lib "C:\DEV\Flowcode V3\Components\USB Pack\Current\DLL Interface\V4\VB_App\ECIO_api.dll" (ByRef pDataOut As Any, ByVal dwLenOut As Long, ByRef pActualLenOut As Long, ByRef pDataIn As Any, ByVal dwExpectedLenIn As Long, ByRef pActualLenIn As Long, ByVal dwTimeout As Long) As Long
    Private Declare Function ECIO_GetDeviceCount Lib "C:\DEV\Flowcode V3\Components\USB Pack\Current\DLL Interface\V4\VB_App\ECIO_api.dll" (ByRef pVID_PID As Any) As Long
#End If


Private sID(0 To 20) As Byte
Private state As Byte


Private Sub Form_Load()
    'Set the identifier
    sID(0) = Asc("v")
    sID(1) = Asc("i")
    sID(2) = Asc("d")
    sID(3) = Asc("_")
    sID(4) = Asc("1")
    sID(5) = Asc("2")
    sID(6) = Asc("b")
    sID(7) = Asc("f")
    sID(8) = Asc("&")
    sID(9) = Asc("p")
    sID(10) = Asc("i")
    sID(11) = Asc("d")
    sID(12) = Asc("_")
    sID(13) = Asc("0")
    sID(14) = Asc("2")
    sID(15) = Asc("1")
    sID(16) = Asc("0")
    sID(17) = 0

    state = 0

    Dim lRetVal As Long
    lRetVal = ECIO_Open(0, sID(0))

End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
    'Make sure the connection is closed
    ECIO_Close
End Sub

Private Sub Press_Click()

    Timer1.Enabled = True
    
End Sub

Private Sub Timer1_Timer()

    Dim rstate As Byte
    Dim astate As Byte
    Dim gstate As Byte
    Dim wstate As Byte

    Dim lRetVal As Long
    Dim bDataOut(0 To 2) As Byte
    Dim bDataIn(0 To 2) As Byte
    Dim nTxDataCnt As Long
    Dim nRxDataCnt As Long

    If (state = 0) Then
        rstate = 0
        astate = 1
        gstate = 0
        wstate = 0
    End If
    
    If (state = 1) Then
        rstate = 1
        astate = 0
        gstate = 0
        wstate = 1
    End If
    
    If (state = 2) Then
        rstate = 1
        astate = 1
        gstate = 0
        wstate = 0
    End If
    
    If (state = 3) Then
        rstate = 0
        astate = 0
        gstate = 1
        wstate = 0
    End If
    
    state = state + 1
    
    If (state = 4) Then
        state = 0
        Timer1.Enabled = False
    End If
    
    Red.Value = rstate
    Amber.Value = astate
    Green.Value = gstate
    Walk.Value = wstate
    
    bDataOut(0) = 7             'Digital Output Transistor Command
    bDataOut(1) = 1             'Output To channel A (RED)
    bDataOut(2) = rstate        'Value of button
    lRetVal = ECIO_Transmit(bDataOut(0), 3, nTxDataCnt, bDataIn(0), 3, nRxDataCnt, 500)
    
    bDataOut(0) = 7             'Digital Output Transistor Command
    bDataOut(1) = 2             'Output To channel B (AMBER)
    bDataOut(2) = astate        'Value of button
    lRetVal = ECIO_Transmit(bDataOut(0), 3, nTxDataCnt, bDataIn(0), 3, nRxDataCnt, 500)
    
    bDataOut(0) = 7             'Digital Output Transistor Command
    bDataOut(1) = 3             'Output To channel C (GREEN)
    bDataOut(2) = gstate        'Value of button
    lRetVal = ECIO_Transmit(bDataOut(0), 3, nTxDataCnt, bDataIn(0), 3, nRxDataCnt, 500)
    
    bDataOut(0) = 7             'Digital Output Transistor Command
    bDataOut(1) = 4             'Output To channel D (Walk)
    bDataOut(2) = wstate        'Value of button
    lRetVal = ECIO_Transmit(bDataOut(0), 3, nTxDataCnt, bDataIn(0), 3, nRxDataCnt, 500)

End Sub

Private Sub Timer2_Timer()

    Dim lRetVal As Long
    Dim bDataOut(0 To 2) As Byte
    Dim bDataIn(0 To 2) As Byte
    Dim nTxDataCnt As Long
    Dim nRxDataCnt As Long

    bDataOut(0) = 1             'Digital Input Command
    bDataOut(1) = 1             'Input from channel 1 (Press Button)
    lRetVal = ECIO_Transmit(bDataOut(0), 2, nTxDataCnt, bDataIn(0), 3, nRxDataCnt, 500)

    If (bDataIn(0) = 1) Then Timer1.Enabled = True

End Sub
