VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   1725
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   3615
   LinkTopic       =   "Form1"
   ScaleHeight     =   1725
   ScaleWidth      =   3615
   StartUpPosition =   3  'Windows Default
   Begin VB.Timer Timer1 
      Interval        =   100
      Left            =   600
      Top             =   1080
   End
   Begin VB.CheckBox Error 
      Caption         =   "Bulb Damaged"
      Height          =   495
      Left            =   1680
      TabIndex        =   2
      Top             =   840
      Width           =   2175
   End
   Begin VB.CheckBox Bulb 
      Caption         =   "Bulb"
      Height          =   495
      Left            =   1680
      TabIndex        =   1
      Top             =   360
      Width           =   1095
   End
   Begin VB.CheckBox Switch 
      Caption         =   "Input"
      Height          =   495
      Left            =   360
      TabIndex        =   0
      Top             =   360
      Width           =   1095
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Set this to "1" if making an exe or "0" if debugging
'(so that the full paths are included in the declare statements)
#Const EXE_BUILD = 1

#If EXE_BUILD Then
    Private Declare Function ECIO_GetDLLVersion Lib "ECIO_api.dll" () As Long
    Private Declare Function ECIO_Open Lib "ECIO_api.dll" (ByVal index As Long, ByRef pVID_PID As Any) As Long
    Private Declare Function ECIO_Close Lib "ECIO_api.dll" () As Long
    Private Declare Function ECIO_Transmit Lib "ECIO_api.dll" (ByRef pDataOut As Any, ByVal dwLenOut As Long, ByRef pActualLenOut As Long, ByRef pDataIn As Any, ByVal dwExpectedLenIn As Long, ByRef pActualLenIn As Long, ByVal dwTimeout As Long) As Long
    Private Declare Function ECIO_GetDeviceCount Lib "ECIO_api.dll" (ByRef pVID_PID As Any) As Long
#Else
    Private Declare Function ECIO_GetDLLVersion Lib "C:\DEV\Flowcode V3\Components\USB Pack\Current\DLL Interface\V4\VB_App\ECIO_api.dll" () As Long
    Private Declare Function ECIO_Open Lib "C:\DEV\Flowcode V3\Components\USB Pack\Current\DLL Interface\V4\VB_App\ECIO_api.dll" (ByVal index As Long, ByRef pVID_PID As Any) As Long
    Private Declare Function ECIO_Close Lib "C:\DEV\Flowcode V3\Components\USB Pack\Current\DLL Interface\V4\VB_App\ECIO_api.dll" () As Long
    Private Declare Function ECIO_Transmit Lib "C:\DEV\Flowcode V3\Components\USB Pack\Current\DLL Interface\V4\VB_App\ECIO_api.dll" (ByRef pDataOut As Any, ByVal dwLenOut As Long, ByRef pActualLenOut As Long, ByRef pDataIn As Any, ByVal dwExpectedLenIn As Long, ByRef pActualLenIn As Long, ByVal dwTimeout As Long) As Long
    Private Declare Function ECIO_GetDeviceCount Lib "C:\DEV\Flowcode V3\Components\USB Pack\Current\DLL Interface\V4\VB_App\ECIO_api.dll" (ByRef pVID_PID As Any) As Long
#End If


Private sID(0 To 20) As Byte



Private Sub Form_Load()
    'Set the identifier
    sID(0) = Asc("v")
    sID(1) = Asc("i")
    sID(2) = Asc("d")
    sID(3) = Asc("_")
    sID(4) = Asc("1")
    sID(5) = Asc("2")
    sID(6) = Asc("b")
    sID(7) = Asc("f")
    sID(8) = Asc("&")
    sID(9) = Asc("p")
    sID(10) = Asc("i")
    sID(11) = Asc("d")
    sID(12) = Asc("_")
    sID(13) = Asc("0")
    sID(14) = Asc("2")
    sID(15) = Asc("1")
    sID(16) = Asc("0")
    sID(17) = 0

    Dim lRetVal As Long
    lRetVal = ECIO_Open(0, sID(0))

End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
    'Make sure the connection is closed
    ECIO_Close
End Sub


Private Sub In_Click()

End Sub

Private Sub Timer1_Timer()

    Dim lRetVal As Long
    Dim bDataOut(0 To 2) As Byte
    Dim bDataIn(0 To 2) As Byte
    Dim nTxDataCnt As Long
    Dim nRxDataCnt As Long

    'Read Input to detect button press
    bDataOut(0) = 1             'Digital Input Command
    bDataOut(1) = 2             'Read Input Channel I2
    lRetVal = ECIO_Transmit(bDataOut(0), 3, nTxDataCnt, bDataIn(0), 3, nRxDataCnt, 500)
    
    Switch.Value = bDataIn(0)
    
    'If input is set then light bulb
    If bDataIn(0) = 1 Then
    
        'Light Bulb
        bDataOut(0) = 7             'Digital Output Transistor Command
        bDataOut(1) = 1             'Output Channel A
        bDataOut(2) = 1             'Light Bulb
        lRetVal = ECIO_Transmit(bDataOut(0), 3, nTxDataCnt, bDataIn(0), 3, nRxDataCnt, 500)
        
        Bulb.Value = 1
        
        'Read Analogue Bulb Test
        bDataOut(0) = 3             'Analogue Input Command
        bDataOut(1) = 1             'Input Channel I1
        lRetVal = ECIO_Transmit(bDataOut(0), 3, nTxDataCnt, bDataIn(0), 3, nRxDataCnt, 500)
        
        If bDataIn(0) > 0 Then
        
            'Test Passed - Bulb OK
            'Clear Error LED
            bDataOut(0) = 7             'Digital Output Transistor Command
            bDataOut(1) = 2             'Output Channel B
            bDataOut(2) = 0             'Clear Error LED
            lRetVal = ECIO_Transmit(bDataOut(0), 3, nTxDataCnt, bDataIn(0), 3, nRxDataCnt, 500)
            
            Error.Value = 0
            
        Else
        
            'Test Failed - Bulb Damaged
            'Set Error LED
            bDataOut(0) = 7             'Digital Output Transistor Command
            bDataOut(1) = 2             'Output Channel B
            bDataOut(2) = 1             'Set Error LED
            lRetVal = ECIO_Transmit(bDataOut(0), 3, nTxDataCnt, bDataIn(0), 3, nRxDataCnt, 500)
            
            Error.Value = 1
            
        End If
        
    'Else clear bulb
    Else
    
        'Clear Bulb
        bDataOut(0) = 7             'Digital Output Transistor Command
        bDataOut(1) = 1             'Output Channel A
        bDataOut(2) = 0             'Clear Bulb
        lRetVal = ECIO_Transmit(bDataOut(0), 3, nTxDataCnt, bDataIn(0), 3, nRxDataCnt, 500)
    
        Bulb.Value = 0
    
    End If
    
    

End Sub
